'From Squeak3.7 of ''4 September 2004'' [latest update: #5989] on 12 March 2006 at 2:35:49 pm'!
"Change Set:		Simulation
Date:			11 March 2006
Author:			Boris Gaertner

This is the almost unchanged discrete event simulation package from the Blue Book. The code is based on a package release from 1989 for Smalltalk-80 Version 2.5.
Most of the examples are coded as class methods of SimulationExample."!

Object subclass: #DelayedEvent
	instanceVariableNames: 'resumptionSemaphore resumptionCondition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Simulations'!
Object subclass: #Histogram
	instanceVariableNames: 'tallyArray lowerBound upperBound step minValue maxValue totalValues extraEntries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Simulation statistics gathering'!
Object subclass: #Integrator
	instanceVariableNames: 'function xLow xHigh eps nMax'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CA-Numeric Classes'!

!Integrator commentStamp: '<historical>' prior: 0!
This is the superclass for classes that implement different numerical integration methods.!

Integrator subclass: #MilneRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CA-Numeric Classes'!

!MilneRule commentStamp: '<historical>' prior: 0!
This is a closed Newton-Cotes-integrator of degree 5. It uses five function values. To receive a relieable approximation, the integration is performed repeatedly with finer interval divisions. To reuse the result of a previous iteration, ever integration interval is divided into three subintervals of equal size.

 Example: (evaluate with 'inspect')

  (MilneRule for: [:arg | arg exp]
                   from: 0
                   to: 1.0)
         nMax: 320000;
         eps: 1.0e-8;
        value

!

Integrator subclass: #NewtonRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CA-Numeric Classes'!

!NewtonRule commentStamp: '<historical>' prior: 0!
This is a closed Newton-Cotes-integrator of degree 3, the so-called 3/8 rule.


Example:

(NewtonRule for: [:arg | arg exp]
                   from: 0
                   to: 1.0)
         nMax: 320000;
         eps: 1.0e-8;
        value

The exact result is 1.0 exp - 1.0!

Integrator subclass: #OpenNewtonCotes3Integrator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CA-Numeric Classes'!

!OpenNewtonCotes3Integrator commentStamp: '<historical>' prior: 0!
This implements an open Newton-Cotes-Integrator of convergence order 3.
Open Newton-Cotes-integrators do not evaluate the integrand at the endpoints of the integration interval. These integrators are therefore recommended for integrands that do not have finite values at the endpoints of the integration interval.

Example: (evaluate with 'inspect')


  (OpenNewtonCotes3Integrator for: [:arg | arg exp]
                   from: 0
                   to: 3.0)
         nMax: 320000;
         eps: 1.0e-11;
        value!

Stream subclass: #ProbabilityDistribution
	instanceVariableNames: ''
	classVariableNames: 'U'
	poolDictionaries: ''
	category: 'Statistics-Distributions'!

!ProbabilityDistribution commentStamp: '<historical>' prior: 0!
Initialization of the class is needed.  Use

    ProbabilityDistribution initialize!

ProbabilityDistribution subclass: #ContinuousProbability
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Statistics-Distributions'!

!ContinuousProbability commentStamp: '<historical>' prior: 0!
This is the superclass of all continuous probability distributions.!

ContinuousProbability subclass: #Cauchy
	instanceVariableNames: 'alfa beta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Statistics-Distributions'!
ContinuousProbability subclass: #ChiSquare
	instanceVariableNames: 'degreeOfFreedom constFactor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Statistics-Distributions'!
ProbabilityDistribution subclass: #DiscreteProbability
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Statistics-Distributions'!
DiscreteProbability subclass: #Bernoulli
	instanceVariableNames: 'prob'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Statistics-Distributions'!

!Bernoulli commentStamp: '<historical>' prior: 0!
Does an event occur?

density function answers the probability of occurrence of one of two events!

Bernoulli subclass: #Binomial
	instanceVariableNames: 'n'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Statistics-Distributions'!

!Binomial commentStamp: '<historical>' prior: 0!
how many successes occurred in N trials?

density funciton answers what is the probability that x successes will occur in the next N trials?

i.e., N repeated Bernoulli trials!

ContinuousProbability subclass: #Exponential
	instanceVariableNames: 'mu'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Statistics-Distributions'!
ContinuousProbability subclass: #Fisher
	instanceVariableNames: 'f1 f2 constFactor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Statistics-Distributions'!
Exponential subclass: #Gamma
	instanceVariableNames: 'n'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Statistics-Distributions'!
Bernoulli subclass: #Geometric
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Statistics-Distributions'!

!Geometric commentStamp: '<historical>' prior: 0!
How many repeated, independent Bernoulli trials are needed before the first success is obtained?

e.g., how many seconds before the next car arrives (as versus how many cars arrive in the next 20 sec as in a binomial question)!

ContinuousProbability subclass: #Maxwell
	instanceVariableNames: 'beta constFactor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Statistics-Distributions'!
ContinuousProbability subclass: #Normal
	instanceVariableNames: 'mu sigma'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Statistics-Distributions'!

!Normal commentStamp: '<historical>' prior: 0!
How long before a success occurs or how many events occur in a certain time interval?!

DiscreteProbability subclass: #Poisson
	instanceVariableNames: 'mu'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Statistics-Distributions'!

!Poisson commentStamp: '<historical>' prior: 0!
how many events occur in a unit time?
    used for sampling potential demands by customers for service

    The Poisson is typically the rate at which the service is provided.

    density function determines the probability that, in a unit interval, x events will occur.
!

Object subclass: #Resource
	instanceVariableNames: 'pending resourceName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Simulations'!
Resource subclass: #ResourceCoordinator
	instanceVariableNames: 'whoIsWaiting'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Simulations'!

!ResourceCoordinator commentStamp: 'BG 3/11/2006 10:45' prior: 0!
blue book, page 517!

Resource subclass: #ResourceProvider
	instanceVariableNames: 'amountAvailable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Simulations'!
DiscreteProbability subclass: #SampleSpace
	instanceVariableNames: 'data'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Statistics-Distributions'!
Object subclass: #SampleSpaceWithReplacement
	instanceVariableNames: 'data rand'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Simulation'!
SampleSpaceWithReplacement subclass: #SampleSpaceWithoutReplacement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Simulation'!
Integrator subclass: #SimpsonRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CA-Numeric Classes'!

!SimpsonRule commentStamp: '<historical>' prior: 0!
This is a closed Newton-Cotes-integrator of degree 3. It uses three function values. To receive a relieable approximation, the integration is performed repeatedly with finer interval divisions. To reuse the result of a previous iteration, ever integration interval is divided into three subintervals of equal size.

Example (evaluate with 'inspect'):


  (SimpsonRule for: [:arg | arg exp]
                   from: 0
                   to: 1.0)
         nMax: 320000;
         eps: 1.0e-11;
        value
!

Object subclass: #Simulation
	instanceVariableNames: 'resources currentTime eventQueue processCount terminated'
	classVariableNames: 'RunningSimulation'
	poolDictionaries: ''
	category: 'Simulations'!

!Simulation commentStamp: '<historical>' prior: 0!
Expects to handle several kinds of resources, represented abstractly by class Resource, and concretely by subclasses of Resource:  ResourceProvider, StaticResource, and ResourceCoordinator!

Object subclass: #SimulationObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Simulations'!

!SimulationObject commentStamp: '<historical>' prior: 0!
A SimulationObject represents any object that can be given a sequence of tasks to do.  The class specifies a general control sequence by which the object enters, carries out its tasks, and leaves the simulation.

    Resources can be produced, consumed, acquired, and tested by queries such as amountAvailable, serversWaiting, custoemrsWaiting?!

SimulationObject subclass: #EventMonitor
	instanceVariableNames: 'label'
	classVariableNames: 'Counter DataFile'
	poolDictionaries: ''
	category: 'Simulation statistics gathering'!
Object subclass: #SimulationObjectRecord
	instanceVariableNames: 'entranceTime duration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Simulation statistics gathering'!
SimulationObject subclass: #StaticResource
	instanceVariableNames: 'amount resource priority'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Simulations'!

!StaticResource commentStamp: 'BG 3/12/2006 08:03' prior: 0!
blue book, page 487-488

A StaticResource represents a SimulationObject with no tasks to do other that to hold quantities of items for other SimulationObjects.!

Simulation subclass: #StatisticsWithSimulation
	instanceVariableNames: 'statistics'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Simulation statistics gathering'!

!StatisticsWithSimulation commentStamp: 'BG 3/11/2006 10:18' prior: 0!
blue book, page 467.
This is the superclass of simulations that gather statistics. Instance variable statistics stores a dictionary that keeps a SimulationObjectRecord for every simulation object that enters the simulation.!

ContinuousProbability subclass: #StudentT
	instanceVariableNames: 'degreeOfFreedom constFactor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Statistics-Distributions'!
Integrator subclass: #TrapezRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CA-Numeric Classes'!
ContinuousProbability subclass: #Uniform
	instanceVariableNames: 'startNumber stopNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Statistics-Distributions'!
DelayedEvent subclass: #WaitingSimulationObject
	instanceVariableNames: 'amount resource'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Simulations'!

!WaitingSimulationObject commentStamp: 'BG 3/11/2006 10:49' prior: 0!
This class is not part of the framework that is described in the blue book. Regrettably, I do not know who added this class to the framework.!

ContinuousProbability subclass: #Weibull
	instanceVariableNames: 'alfa beta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Statistics-Distributions'!

!DelayedEvent methodsFor: 'accessing'!
condition
    "Answer a condition under which the event should be sequenced."

    ^resumptionCondition! !

!DelayedEvent methodsFor: 'accessing'!
condition: anObject
    "The argument, anObject, is the condition under which the event should be sequenced."

    resumptionCondition := anObject! !

!DelayedEvent methodsFor: 'comparing'!
<= aDelayedEvent
    "Answer whether the receiver should be sequenced before the argument."
    
    resumptionCondition isNil
        ifTrue: [^true]
        ifFalse: [^resumptionCondition <= aDelayedEvent condition]! !

!DelayedEvent methodsFor: 'scheduling'!
pause
    "Suspend the current active process, that is, the current event that is running."

    Simulation active stopProcess.
    resumptionSemaphore wait! !

!DelayedEvent methodsFor: 'scheduling'!
resume
    "Resume the suspended process."
    Simulation active startProcess.
    resumptionSemaphore signal.
    ^resumptionCondition! !

!DelayedEvent methodsFor: 'scheduling' stamp: 'BG 3/9/2006 22:40'!
terminateWaitingProcess
    "Resume the suspended process."
   
    resumptionSemaphore terminateProcess.
    ^resumptionCondition! !

!DelayedEvent methodsFor: 'private'!
initialize
    resumptionSemaphore := Semaphore new! !

!DelayedEvent methodsFor: 'private'!
setCondition: anObject
    self initialize.
    resumptionCondition := anObject! !


!DelayedEvent class methodsFor: 'instance creation'!
onCondition: anObject
    ^super new setCondition: anObject! !


!Histogram methodsFor: 'accessing'!
contains: aValue
    ^lowerBound <= aValue and: [aValue < upperBound]! !

!Histogram methodsFor: 'accessing'!
store: aValue 
    | index |
    minValue isNil
        ifTrue: [minValue := maxValue := aValue]
        ifFalse: 
            [minValue := minValue min: aValue.
            maxValue := maxValue max: aValue].
    totalValues := totalValues + aValue.
    (self contains: aValue)
        ifTrue: 
            [index := (aValue - lowerBound // step) + 1.
            tallyArray at: index put: (tallyArray at: index) + 1]
        ifFalse: [extraEntries := extraEntries + 1]! !

!Histogram methodsFor: 'printing'!
firstHeader: aStream
    aStream cr; tab.
    aStream nextPutAll: 'Number of '.
    aStream tab.
    aStream nextPutAll: 'Minimum '.
    aStream tab.
    aStream nextPutAll: 'Maximum '.
    aStream tab.
    aStream nextPutAll: 'Average '.
    aStream cr; tab.
    aStream nextPutAll: 'Objects '.
    aStream tab.
    aStream nextPutAll: 'Value '.
    aStream tab.
    aStream nextPutAll: 'Value '.
    aStream tab.
    aStream nextPutAll: 'Value '.! !

!Histogram methodsFor: 'printing'!
printStatisticsOn: aStream 
    | totalObjs pos |
    self firstHeader: aStream.
    aStream cr; tab.
    totalObjs := extraEntries.
    tallyArray do: [:each | totalObjs := totalObjs + each].
    totalObjs printOn: aStream.
    aStream tab.
    minValue printOn: aStream.
    aStream tab.
    maxValue printOn: aStream.
    aStream tab.
    (totalValues / totalObjs) asFloat printOn: aStream.
    aStream cr.
    self secondHeader: aStream.
    aStream cr.
    pos := lowerBound.
    tallyArray do: 
        [:entry | 
        pos printOn: aStream.
        aStream nextPut: $-.
        (pos := pos + step) printOn: aStream.
        aStream tab.
        entry printOn: aStream.
        aStream tab.
        (entry / totalObjs) asFloat printOn: aStream.
        aStream tab.
        aStream nextPut: $|.
        entry rounded timesRepeat: [aStream nextPut: $X].
        aStream cr]! !

!Histogram methodsFor: 'printing'!
secondHeader: aStream
    aStream cr; tab.
    aStream nextPutAll: 'Number of '.
    aStream cr.
    aStream nextPutAll: 'Entry '.
    aStream tab.
    aStream nextPutAll: 'Objects '.
    aStream tab.
    aStream nextPutAll: 'Frequency '.! !

!Histogram methodsFor: 'private'!
newLower: lowerNum upper: upperNum by: stepAmount
    tallyArray := Array new: (upperNum - lowerNum // stepAmount).
    tallyArray atAllPut: 0.
    lowerBound := lowerNum.
    upperBound := upperNum.
    step := stepAmount.
    minValue := maxValue := nil.
    totalValues := 0.
    extraEntries := 0! !


!Histogram class methodsFor: 'class initialization'!
from: lowerNum to: upperNum by: step
    ^self new newLower: lowerNum upper: upperNum by: step! !


!Integrator methodsFor: 'accessing' stamp: 'BG 03/25/2000 21:55'!
eps: aFloat

    eps := aFloat.! !

!Integrator methodsFor: 'accessing' stamp: 'BG 03/25/2000 21:55'!
function: aFunction

   function := aFunction.
   eps := 1.0e-6.
   nMax := 500.! !

!Integrator methodsFor: 'accessing' stamp: 'BG 03/25/2000 21:55'!
function: aFunction
          from: xL
            to: xH

   function := aFunction.
   xLow := xL.
   xHigh := xH.
   eps := 1.0e-6.
   nMax := 500.! !

!Integrator methodsFor: 'accessing' stamp: 'BG 03/25/2000 21:55'!
nMax: anInteger

  nMax := anInteger.! !

!Integrator methodsFor: 'integration' stamp: 'BG 11/17/2000 20:17'!
integrate: nroOfIntervals with: aClass

  | integralValue interval xLeft xRight
    valueInSubinterval integrator |

  integrator := aClass for: function.
  integrator nMax: nMax; eps: eps.
  integralValue := 0.0.
  interval := xHigh - xLow / nroOfIntervals.
  xLeft := xLow.
  xRight := xLow + interval.

  nroOfIntervals timesRepeat:
    [ "  here we have a problem "
   "  Transcript show: xLeft printString; show: '   '; show: xRight printString; cr. "
     valueInSubinterval :=
        integrator valueFrom: xLeft to: xRight.
     integralValue := integralValue + valueInSubinterval.
     xLeft := xRight.
     xRight := xRight + interval.
    ].

  ^integralValue! !

!Integrator methodsFor: 'integration' stamp: 'BG 03/25/2000 21:55'!
valueFrom: xLeft to: xRight

   "  integrate your function from start point  xLeft
      to endpoint xRight.  The values  eps, nMax  are
      assumed to be previously set. "

  xLow := xLeft.
  xHigh := xRight.
  ^self value! !


!Integrator class methodsFor: 'instance creation' stamp: 'BG 03/25/2000 21:55'!
for: aFunction

   ^self new
      function: aFunction! !

!Integrator class methodsFor: 'instance creation' stamp: 'BG 4/4/2001 23:16'!
for: aFunction from: xL to: xH

   ^self new
      function: aFunction
          from: xL
            to: xH

  " example:
      | f |

      f := [:x | x*x].
      (NewtonRule for: f from: 0 to: 1)
      value
    "
    "
      the Gauss distribution:
     (NewtonRule for: [:x | (x*x/2 negated) exp]
                   from: 0
                   to: 0.2)
        value / ((Float pi * 2) sqrt)

  "
     " computation of the Gamma function:
       G(z) = Integrate(exp(-t)*t^(z - 1), t, {t, 0, Inf})
       (NewtonRule
           for:  [:x | x negated exp * (x raisedTo: 0.7 - 1)]
           from: 0.00001
           to: 50)
         nMax: 64000;
        value

         The quality of the result values is very poor. To compute
        the gamma function, very good adaptive integration is needed.
        Use G(x)*G(1 - x) = pi/sin(pi*x) to compute the Gamma value in
the range 0.0< x <0.5
   "
! !


!MilneRule methodsFor: 'integration' stamp: 'BG 4/15/2001 16:24'!
value

  | interval n area xi xj xk factors |

     " compute an initial approximation "
   n := 1.
   interval := xHigh - xLow / 4.0.
   xi := xLow + interval.
   xj := xi + interval.
   xk := xHigh - interval.
   area := ((function value: xj) * 12.0
              + ((function value: xi) + (function value: xk) * 32.0)
              + ((function value: xLow) + (function value: xHigh) * 7.0)
           ) * (xHigh - xLow / 90.0).

   "  begin the repeated division of the integration intervals. "

    factors := #(32.0 12.0 14.0 32.0 32.0 14.0 12.0 32.0).

   [ | oldArea sum xPoints delta |
    oldArea := area.
    sum := 0.0.
    delta := interval / 3.0.
    xPoints := Array new: 8.
    xPoints at: 1 put: delta.
    xPoints at: 2 put: delta * 2.0.
    xPoints at: 3 put: delta * 4.0.
    xPoints at: 4 put: delta * 5.0.
    xPoints at: 5 put: delta * 7.0.
    xPoints at: 6 put: delta * 8.0.
    xPoints at: 7 put: delta * 10.0.
    xPoints at: 8 put: delta * 11.0.

    0 to: n - 1 do:
    [ :i |    | localStart s |
      " compute the function values at the new supporting points.
        Eight new points are needed for evere interval."
       localStart := i*interval * 4 + xLow.
       s := 0.0.
       1 to: xPoints size do:
         [ :j | s := (function value: (xPoints at: j) + localStart) * (factors at: j) + s].
       sum := s + sum.
    ].

    n := n + n + n.
    area := area / 3.0 + (sum * (xHigh - xLow/n / 90.0)).
    interval := interval / 3.0.
    n > nMax or:
      [(area - oldArea) abs <=  (area abs * eps)]
   ]
     whileFalse: [].

  ^area! !


!NewtonRule methodsFor: 'integration' stamp: 'BG 4/14/2001 13:18'!
value

  | interval n area xi xj xk |

     " compute an initial approximation "
   interval := xHigh - xLow / 3.0.
   xi := xLow + interval.
   xk := xHigh - interval.
   area := ((function value: xi) + (function value: xk) * 3
              + (function value: xLow) + (function value: xHigh)
           ) * (xHigh - xLow / 8.0).

   n := 1. " number of intervals "

   [ | oldArea sum |
    oldArea := area.
    sum := 0.0.

    0 to: n - 1 do:
    [ :i |    | localStart |
       localStart := i*interval * 3 + xLow.
       xi := interval / 2.0 + localStart.
       xj := interval * 1.5 + localStart.
       xk := interval * 2.5 + localStart.
     sum := (function value: xj) * 2
            + ((function value: xi) + (function value: xk) * 3)
            + sum.
    ].

    n := n + n.
    area := area / 2.0 + (sum * (xHigh - xLow /n / 8)).
    interval := interval / 2.0.
    n > nMax or:
      [(area - oldArea) abs <=  (area abs * eps)]
   ]
     whileFalse: [].

  ^area! !

!NewtonRule methodsFor: 'integration' stamp: 'BG 5/11/2001 08:16'!
valueWithInitialNumberOfIntervals: n0

  | interval n area xi xj xk |

     " compute an initial approximation "
   interval := xHigh - xLow / 3.0.
   xi := xLow + interval.
   xk := xHigh - interval.
   area := ((function value: xi) + (function value: xk) * 3
              + (function value: xLow) + (function value: xHigh)
           ) * (xHigh - xLow / 8.0).

   n := 1. " number of intervals "

   [ | oldArea sum |
    oldArea := area.
    sum := 0.0.

    0 to: n - 1 do:
    [ :i |    | localStart |
       localStart := i*interval * 3 + xLow.
       xi := interval / 2.0 + localStart.
       xj := interval * 1.5 + localStart.
       xk := interval * 2.5 + localStart.
     sum := (function value: xj) * 2
            + ((function value: xi) + (function value: xk) * 3)
            + sum.
    ].

    n := n + n.
    area := area / 2.0 + (sum * (xHigh - xLow /n / 8)).
    interval := interval / 2.0.
    n > nMax or:
      [n > n0 and: [(area - oldArea) abs <=  (area abs * eps)]]
   ]
     whileFalse: [].

  ^area! !


!OpenNewtonCotes3Integrator methodsFor: 'integration' stamp: 'BG 4/15/2001 16:21'!
value

  | interval n area xi xj xk factors |

     " compute an initial approximation "
   n := 1. " number of intervals "
   interval := xHigh - xLow / 4.0.
   xi := xLow + interval.
   xj := xi + interval.
   xk := xHigh - interval.
   area := (((function value: xi) + (function value: xk)) * 2
               - (function value: xj)
           ) * (xHigh - xLow / 3.0).

   "  begin the repeated division of the integration intervals. "

    factors := #(2.0 -1.0 2.0 2.0 -1.0 2.0).

   [ | oldArea sum xPoints delta |
    oldArea := area.
    sum := 0.0.
    delta := interval / 3.0.
    xPoints := Array new: 6.
    xPoints at: 1 put: delta.
    xPoints at: 2 put: delta * 2.0.
    xPoints at: 3 put: delta * 5.0.
    xPoints at: 4 put: delta * 7.0.
    xPoints at: 5 put: delta * 10.0.
    xPoints at: 6 put: delta * 11.0.

    0 to: n - 1 do:
    [ :i |    | localStart s |
      " compute the function values at the new supporting points.
        Eight new points are needed for evere interval."
       localStart := i*interval * 4 + xLow.
       s := 0.0.
       1 to: xPoints size do:
         [ :j | s := (function value: (xPoints at: j) + localStart) * (factors at: j) + s].
       sum := s + sum.
    ].

    n := n + n + n.
    area := area / 3.0 + (sum * (xHigh - xLow/n / 3.0)).
    interval := interval / 3.0.
    n > nMax or:
      [(area - oldArea) abs <=  (area abs * eps)]
   ]
     whileFalse: [].

  ^area
! !


!ProbabilityDistribution methodsFor: 'random sampling'!
atEnd
    ^false! !

!ProbabilityDistribution methodsFor: 'random sampling'!
next
    "This is a general random number generation method for any probability law;  use the (0,1) uniformly distributed random varible U as the value of the law's distribution function.  Obtain the next random value and then solve for the inverse.  The inverse solution is defined by the subclass."

    ^self inverseDistribution: U next! !

!ProbabilityDistribution methodsFor: 'probability functions'!
density: x

    self subclassResponsibility! !

!ProbabilityDistribution methodsFor: 'probability functions'!
distribution: aCollection

    self subclassResponsibility! !

!ProbabilityDistribution methodsFor: 'private'!
computeSample: m outOf: n

    m>n ifTrue: [^0.0].
    ^n factorial / (n-m) factorial! !

!ProbabilityDistribution methodsFor: 'private'!
inverseDistribution: x
    self subclassResponsibility! !


!ContinuousProbability methodsFor: 'probability functions' stamp: 'BG 3/12/2006 14:35'!
distribution: aCollection
    "This is a slow and dirty trapezoidal integration to determine the area under the probability function curve y=density (x) for x in the specified collection.  The method assumes that the collection contains numerically-ordered elements."

    | t aStream x1 x2 y1 y2 |
    t := 0.0.
    aStream := ReadStream on: aCollection.
    x2 := aStream next.
    y2 := self density: x2.
    [x1 := x2.  
	x2 := aStream next.
	x2 notNil]
        whileTrue: 
            [y1 := y2.
              y2 := self density: x2.
             t := t + ((x2-x1)*(y2+y1))].
    ^t*0.5! !

!ContinuousProbability methodsFor: 'probability functions' stamp: 'BG 3/23/2001 20:52'!
distributionBetween: leftBorder and: rightBorder

   "   The method assumes that leftborder <= rightBorder."

    ^(NewtonRule for: [:arg | self density: arg]
                   from: leftBorder
                   to: rightBorder) value! !


!Cauchy methodsFor: 'probability functions' stamp: 'BG 4/9/2001 19:00'!
density: x

   ^((x - alfa / beta) squared + 1 * beta * Float pi) reciprocal! !

!Cauchy methodsFor: 'private' stamp: 'BG 4/9/2001 19:02'!
setAlfa: a beta: b

    alfa := a.
    beta := b.! !

!Cauchy methodsFor: 'visualization support' stamp: 'BG 4/11/2001 23:19'!
usefulDisplayRange
    | maxVal order multiplier |

   maxVal := self density: alfa.
"    Transcript show: maxVal printString; cr. "
   order := maxVal log ceiling.
   multiplier := 10 raisedToInteger: order - 1.
   maxVal := (maxVal / multiplier) ceiling * multiplier.

   ^Array with: (Array with: alfa - (2.5 * beta)
                            with: alfa + (2.5 * beta))
            with: (Array with: 0 
                            with: maxVal)! !


!ChiSquare methodsFor: 'probability functions' stamp: 'BG 4/8/2001 21:59'!
density: x

    ^x <= 0 ifTrue: [0]
           ifFalse:
             [  | num exp |
            "   num := (x raisedTo: (degreeOfFreedom/2 - 1))*(x negated / 2) exp. "
               num := (exp := (degreeOfFreedom/2 - 1) * (x ln) - (x / 2)) exp.
               num printString = 'Infinity' ifTrue: [self halt].
               num * constFactor
            ]! !

!ChiSquare methodsFor: 'probability functions' stamp: 'BG 4/1/2001 22:47'!
distributionAt: x

   "  return the value of the distribution function for the interval from 0.0 to  x.
      For one degree of freedom the density function has a pole at zero and is
      therefore difficult to integrate. We use the following results:
      Integrate(exp(-x/2)/(sqrt(2*pi)*sqrt(x)), x, 0, z) =
           (sqrt(2*pi) - sqrt(2)*G(1/2, z/2))/sqrt(2*pi)
      with G(1/2, z/2) = Integrate(exp(-t)/sqrt(t), t, z/2, Inf)
      The numerical values are acceptable, but the computation times are quite high.
      An adaptive integrator would certainly do better.
   "

        degreeOfFreedom = 1
       ifTrue:
         [| g f |
           g := (NewtonRule for: [:arg | arg negated exp /arg sqrt]
                   from: x/2
                   to: 1000)
                nMax: 64000;
                eps: 1.0e-7;

                 value.
           f := (Float pi * 2) sqrt.
           ^f - (2 sqrt * g) / f
         ].

     ^(NewtonRule for: [:arg | self density: arg]
                   from: 0
                   to: x)
        value! !

!ChiSquare methodsFor: 'probability functions' stamp: 'BG 4/1/2001 22:12'!
distributionBetween: leftBorder and: rightBorder

   "   The method assumes that leftborder <= rightBorder."

    degreeOfFreedom = 1
       ifTrue:
         [self halt].
    ^(NewtonRule for: [:arg | self density: arg]
                   from: leftBorder
                   to: rightBorder) value! !

!ChiSquare methodsFor: 'probability functions' stamp: 'BG 4/8/2001 21:46'!
valueForErrorProbability: a

    "  here we use the fact that the density function is  symmetric at zero. It is
       therefore possible to use the equality
       We use a bisection algorithm to find the value of z for which the
       integral Integrate(density(x), 0, z) gives the value 1 - a  "

       | startValue f min max mean d  |

   startValue := 5.0. 
   f := self distributionAt: startValue.
   d := 1.0 - f abs.
   "1 - f" d > a
     ifTrue:
       [[min := startValue.
         startValue := startValue + startValue.
         f := self distributionAt: startValue.
         1.0 - f > a
        ] whileTrue: [].
        max := startValue.
       ]
     ifFalse:
       [[max := startValue.
         startValue := startValue / 2.0.
         f := self distributionAt: startValue.
         1.0 - f > a
        ] whileFalse: [].
        min := startValue.
       ].
     [mean := min + max / 2.0.
         f := self distributionAt: mean.
      (1 - f - a) abs < 1.0e-7
          ifTrue: [^mean]. 
      1 - f > a
         ifTrue: [min := mean]
         ifFalse: [max := mean].
      ] repeat.

! !

!ChiSquare methodsFor: 'private' stamp: 'BG 3/27/2001 02:37'!
gamma: arg

   (arg isKindOf: Integer)
      ifTrue: [^(arg - 1) factorial]
      ifFalse:
       [ 1/2 = arg ifTrue: [^Float pi sqrt]
                    ifFalse: [^arg - 1 * (self gamma: arg - 1)]
       ].! !

!ChiSquare methodsFor: 'private' stamp: 'BG 3/26/2001 13:58'!
setDegreeOfFreedom: n

      | g2 |
    degreeOfFreedom := n.
    g2 := self gamma: n/2.
    constFactor := 1/(g2*(2 raisedTo: n/2))! !

!ChiSquare methodsFor: 'visualization support' stamp: 'BG 5/2/2001 20:10'!
usefulDisplayRange

    "  return a region that can be used to display the density function. "

   |  xMax yMax order multiplier |

   xMax := self valueForErrorProbability: 0.03.
   order := xMax log ceiling.
   multiplier := 10 raisedToInteger: order - 1.
   xMax := (xMax / multiplier) ceiling * multiplier.
   " Transcript show: xMax printString; cr. "
    "  yMax should be computed with the bisection method "
   yMax := 6.0 / xMax.
 "  Transcript show: xMax printString; show: '       '; show: yMax printString; cr. "
   ^Array with: (Array with: 0
                            with: xMax)
            with: (Array with: 0 
                            with: yMax)! !


!DiscreteProbability methodsFor: 'probability functions' stamp: 'BG 3/21/2001 20:13'!
distribution: aCollection
  "  Answer the sum of the discrete values of the density
     function for each element in the collection."

    | t |
   t := 0.0.
   aCollection do: [:i | t := t + (self density: i)].
  ^t! !


!Bernoulli methodsFor: 'accessing'!
mean
    ^prob! !

!Bernoulli methodsFor: 'accessing'!
variance
    ^prob * (1.0 - prob)! !

!Bernoulli methodsFor: 'probability functions'!
density: x

    x=1 ifTrue: [^prob].
    x=0 ifTrue: [^1.0-prob].
    self error: ' outcomes of a Bernoulli can only be 1 or 0'! !

!Bernoulli methodsFor: 'private'!
inverseDistribution: x

    x <= prob
        ifTrue: [^1]
        ifFalse: [^0]! !

!Bernoulli methodsFor: 'private'!
setParameter: aNumber
    prob :=aNumber! !


!Binomial methodsFor: 'probability functions' stamp: 'BG 1/26/2002 18:34'!
density: x

    (x between: 0 and: n)
        ifTrue: [^((self computeSample: x outOf: n) / (self computeSample: x outOf: x)) * (prob raisedTo: x)*((1.0 - prob) raisedTo: n-x)]
        ifFalse: [^0.0]! !

!Binomial methodsFor: 'random sampling' stamp: 'BG 1/26/2002 18:35'!
next
    
    |t|
    t := 0.
    n timesRepeat: [t := t + super next].
    ^t! !

!Binomial methodsFor: '-- all --' stamp: 'BG 3/21/2001 21:20'!
events: n1 mean: m

  n := n1 truncated.
  self setParameter: m/n! !


!Exponential methodsFor: 'accessing'!
mean
    ^1.0/mu! !

!Exponential methodsFor: 'accessing'!
variance
    ^1.0/(mu*mu)! !

!Exponential methodsFor: 'private'!
inverseDistribution: x
    ^ x ln negated / mu! !

!Exponential methodsFor: 'private'!
setParameter: p
    mu := p! !

!Exponential methodsFor: 'probability functions'!
density: x
    x > 0.0
        ifTrue: [^mu * (mu*x) negated exp]
        ifFalse: [^0.0]! !

!Exponential methodsFor: 'probability functions' stamp: 'BG 3/21/2001 19:54'!
distribution: anInterval

   anInterval last <= 0.0
     ifTrue: [^0.0]
     ifFalse:
      [^1.0 - (mu * anInterval last) negated exp
            - (anInterval first > 0.0
                 ifTrue: [self distribution: (0.0 to: anInterval first)]
                 ifFalse: [0.0]
              )
      ]! !


!Fisher methodsFor: 'private' stamp: 'BG 4/4/2001 21:34'!
betaOf: a and: b

    ^self primitiveBeta: a*2 - 1 and: b*2 - 1! !

!Fisher methodsFor: 'private' stamp: 'BG 4/4/2001 20:14'!
gamma: arg

   (arg isKindOf: Integer)
      ifTrue: [^(arg - 1) factorial]
      ifFalse:
       [ 1/2 = arg ifTrue: [^Float pi sqrt]
                    ifFalse: [^arg - 1 * (self gamma: arg - 1)]
       ].! !

!Fisher methodsFor: 'private' stamp: 'BG 4/5/2001 20:20'!
primitiveBeta: a and: b

   ! !

!Fisher methodsFor: 'private' stamp: 'BG 4/5/2001 20:20'!
setDegreesOfFreedom: a and: b

   " the constant factor is:
     f1^(f1/2)*f2^(f2/2)*Gamma(f1/2 + f2/2)/(Gamma(f1/2)*Gamma(f2/2))  "
  
        | p1 p2 b1 b2 g1 g2 g3 |
    f1 := a.
    f2 := b.
    p1 := f1 raisedTo: f1/2.
    p2 := f2 raisedTo: f2/2.
    g3 := self gamma: f1 + f2 / 2.
    g1 := self gamma: f1/2.
    g2 := self gamma: f2/2.
    b1 := g1*g2/g3.
    b2 := self betaOf: f1/2 and: f2/2.
  
    constFactor := p1 * p2 / b1
  
    ! !

!Fisher methodsFor: 'probability functions' stamp: 'BG 4/4/2001 22:54'!
density: x

    ^constFactor* (x raisedTo: (f1/2 - 1))/((f1*x + f2) raisedTo: (f2 + f1 / 2))! !

!Fisher methodsFor: 'probability functions' stamp: 'BG 4/4/2001 23:00'!
valueForErrorProbability: a

    " The integral Integrate(density(x), 0, z) gives the value 1 - a  "

       | startValue f min max mean |

   startValue := 10.0.
   f := self distributionBetween: 0.0 and: startValue.
   1 - f > a
     ifTrue:
       [[min := startValue.
         startValue := startValue + startValue.
         f := self distributionBetween: 0.0 and: startValue.
         1 - f > a
        ] whileTrue: [].
        max := startValue.
       ]
     ifFalse:
       [[max := startValue.
         startValue := startValue / 2.0.
         f := self distributionBetween: 0.0 and: startValue.
         1 - f > a
        ] whileFalse: [].
        min := startValue.
       ].
     [mean := min + max / 2.0.
         f := self distributionBetween: 0.0 and: mean.
      (1 - f - a) abs < 1.0e-7
          ifTrue: [^mean]. 
      1 - f > a
         ifTrue: [min := mean]
         ifFalse: [max := mean].
      ] repeat.! !

!Fisher methodsFor: 'visualization support' stamp: 'BG 4/8/2001 20:54'!
usefulDisplayRange

    "  return a region that can be used to display the density function. "

   |  xMax yMax |

   xMax := self valueForErrorProbability: 0.05.
    "  yMax should be computed with the bisection method "
   yMax := 1.0.
   ^Array with: (Array with: 0
                            with: xMax ceiling)
            with: (Array with: 0 
                            with: yMax)! !


!Gamma methodsFor: 'accessing' stamp: 'BG 1/26/2002 18:33'!
mean
    ^super mean*n! !

!Gamma methodsFor: 'accessing' stamp: 'BG 1/26/2002 18:33'!
variance
    ^super variance*n! !

!Gamma methodsFor: 'probability functions' stamp: 'BG 1/26/2002 18:33'!
density: x
    | t |
    x > 0.0
        ifTrue: [t := mu * x.
            ^(mu raisedTo: n) / (self gamma: n) *(x raisedTo: n-1) * t negated exp]
        ifFalse: [^0.0]! !

!Gamma methodsFor: 'private' stamp: 'BG 1/26/2002 18:38'!
gamma: n1
    | t |
    t := n1 - 1.0.
    ^self computeSample: t outOf: t! !

!Gamma methodsFor: 'private' stamp: 'BG 1/26/2002 18:38'!
setEvents: events
    n := events! !


!Geometric methodsFor: 'accessing'!
mean
    ^ 1.0 / prob! !

!Geometric methodsFor: 'accessing'!
variance
    ^ (1.0 - prob) / prob squared! !

!Geometric methodsFor: 'probability functions'!
density: x

    x>0 ifTrue: [^prob * ((1.0 - prob) raisedTo: x-1)]
        ifFalse: [^0.0]! !

!Geometric methodsFor: 'private'!
inverseDistribution: x

    ^(x ln / (1.0 - prob) ln) ceiling! !


!Maxwell methodsFor: 'private' stamp: 'BG 4/9/2001 10:03'!
for: b

     | b3 |
   beta := b.
   b3 := b raisedToInteger: 3.
   constFactor := 4 / (Float pi sqrt * b3).! !

!Maxwell methodsFor: 'probability functions' stamp: 'BG 4/9/2001 10:02'!
density: x

  ^ x <= 0
      ifTrue: [0.0]
      ifFalse:
        [(x/beta) squared negated exp * x squared * constFactor]
   ! !


!Normal methodsFor: 'accessing'!
mean
    ^mu! !

!Normal methodsFor: 'accessing'!
variance
    ^sigma squared! !

!Normal methodsFor: 'random sampling'!
next
    | v1 v2 s rand u |
    rand := Uniform from: -1.0 to: 1.0.
    [v1 := rand next.
     v2 := rand next.
     s := v1 squared + v2 squared.
     s >= 1] whileTrue.
    u := (-2.0 * s ln /s) sqrt.
    ^mu + (sigma * v1 *u)! !

!Normal methodsFor: 'probability functions'!
density: x

    | twoPi t |
    twoPi := 2 * 3.1415926536.
    t := x - mu/sigma.
    ^(-0.5 * t squared) exp / (sigma * twoPi sqrt)! !

!Normal methodsFor: 'probability functions' stamp: 'BG 9/25/2003 16:55'!
distributionAt: x

   "  return the value of the distribution function at  x "

    | lambda absValue |

     lambda := x - mu / sigma.
     absValue := 
       (NewtonRule for: [:arg | (arg*arg/2 negated) exp]
                   from: 0
                   to: lambda abs)
        value / ((Float pi * 2) sqrt).
     ^lambda < 0
       ifTrue: [absValue negated]
       ifFalse: [absValue].! !

!Normal methodsFor: 'private'!
setMean: m standardDeviation: s
    mu := m.
    sigma := s! !

!Normal methodsFor: 'visualization support' stamp: 'BG 4/11/2001 23:15'!
usefulDisplayRange

    "  return a region that can be used to display the density function.
       This method uses the fact, that the region from mu -2.5*sigma to
       ms + 2.5*sigma encloses almost 99 percent of the area below the
       bell-shaped function. "

    | maxVal order multiplier |
   maxVal := self density: mu.
"    Transcript show: maxVal printString; cr. "
   order := maxVal log ceiling.
   multiplier := 10 raisedToInteger: order - 1.
   maxVal := (maxVal / multiplier) ceiling * multiplier.
   ^Array with: (Array with: mu - (2.5 * sigma)
                            with: mu + (2.5 * sigma))
            with: (Array with: 0 
                            with: maxVal)! !


!Poisson methodsFor: 'accessing'!
mean
    ^mu! !

!Poisson methodsFor: 'accessing'!
variance
    ^mu! !

!Poisson methodsFor: 'probability functions'!
density: x

    x >= 0
        ifTrue: [^ ((mu raisedTo: x) * (mu negated exp)) / x factorial]
        ifFalse: [^0.0]! !

!Poisson methodsFor: 'random sampling'!
next
    | p n q |
    p := mu negated exp.
    n := 0.
    q := 1.0.
    [q := q * U next.
     q >= p]
        whileTrue: [n := n + 1].
    ^n! !

!Poisson methodsFor: 'private'!
setMean: p
    mu := p! !


!ProbabilityDistribution class methodsFor: 'instance creation'!
new
    
    ^self basicNew! !

!ProbabilityDistribution class methodsFor: 'class initialization'!
initialize
    "Uniformly distributed random numbers in the range [o,1]."

    U := Random new! !


!Bernoulli class methodsFor: 'instance creation'!
parameter: aNumber
    (aNumber between: 0.0 and: 1.0)
        ifTrue: [^self new setParameter: aNumber]
        ifFalse: [^self error: 'The probability must be between 0.0 and 1.0']! !

!Bernoulli class methodsFor: 'Examples'!
Cardgame

    "is the first draw of a card an ace?"
    (Bernoulli parameter: 4/52) next

    "does a car arrive in the next second?"

    "will a machine break down today?"! !


!Binomial class methodsFor: 'instance creation'!
events: n mean: m

    n truncated <= 0 ifTrue: [self error: 'number of events must be > 0'].
    ^self new events: n mean: m! !

!Binomial class methodsFor: 'Examples'!
FlippingCoins

    | sampleA sampleB |
    sampleA := Bernoulli parameter: 0.5.

    "Did I get heads?"
    sampleA next.

    sampleB := Binomial events: 5 mean: 2.5.
    
    "How many heads did I get in 5 trials?"
    sampleB next! !


!Cauchy class methodsFor: 'instance creation' stamp: 'BG 4/9/2001 19:02'!
forAlfa: a beta: b

    ^self new setAlfa: a beta: b! !

!Cauchy class methodsFor: 'facts representation' stamp: 'BG 4/9/2001 19:09'!
canHaveTwoTails

   ^true! !

!Cauchy class methodsFor: 'facts representation' stamp: 'BG 4/9/2001 19:01'!
instanceCreationMethod

   ^#forAlfa:beta:! !

!Cauchy class methodsFor: 'facts representation' stamp: 'BG 4/9/2001 19:03'!
isSymmetric

   ^false! !

!Cauchy class methodsFor: 'facts representation' stamp: 'BG 4/9/2001 10:04'!
nameOfDistribution

   ^'Cauchy-Distribution'! !

!Cauchy class methodsFor: 'facts representation' stamp: 'BG 4/9/2001 19:04'!
parameters

  ^Array with: (Array with: 'alfa' with: Float)
           with: (Array with: 'beta' with: Float)! !


!ChiSquare class methodsFor: 'instance creation' stamp: 'BG 4/8/2001 20:20'!
forDegreesOfFreedom: n

   ^self new setDegreeOfFreedom: n! !

!ChiSquare class methodsFor: 'facts representation' stamp: 'BG 4/5/2001 21:29'!
canHaveTwoTails

   ^false! !

!ChiSquare class methodsFor: 'facts representation' stamp: 'BG 4/8/2001 20:20'!
instanceCreationMethod

   ^#forDegreesOfFreedom:! !

!ChiSquare class methodsFor: 'facts representation' stamp: 'BG 4/5/2001 21:29'!
isSymmetric

   ^false! !

!ChiSquare class methodsFor: 'facts representation' stamp: 'BG 4/5/2001 21:29'!
nameOfDistribution

   ^'Chi Square'! !


!Exponential class methodsFor: 'instance creation'!
mean: p
    ^self parameter: 1.0/p! !

!Exponential class methodsFor: 'instance creation'!
parameter:  p
    
    p > 0.0
        ifTrue: [^self new setParameter: p]
        ifFalse: [self error: 'The probability parameter must be greater than 0.0']! !

!Exponential class methodsFor: 'facts representation' stamp: 'BG 4/9/2001 10:06'!
nameOfDistribution

   ^'Exponential Distribution'! !


!Fisher class methodsFor: 'instance creation' stamp: 'BG 4/2/2001 14:12'!
forDegreesOfFreedom: f1 and: f2

   ^self new setDegreesOfFreedom: f1 and: f2! !

!Fisher class methodsFor: 'facts representation' stamp: 'BG 4/5/2001 20:27'!
canHaveTwoTails

   ^false! !

!Fisher class methodsFor: 'facts representation' stamp: 'BG 4/8/2001 19:55'!
instanceCreationMethod

   ^#forDegreesOfFreedom:and:! !

!Fisher class methodsFor: 'facts representation' stamp: 'BG 4/5/2001 20:26'!
isSymmetric

   ^false! !

!Fisher class methodsFor: 'facts representation' stamp: 'BG 4/5/2001 20:26'!
nameOfDistribution

   ^'F-Distribution'! !


!Gamma class methodsFor: 'instance creation'!
events: k mean: p

    |  events |
    events := k truncated.
    events > 0
        ifTrue: [^(self parameter: events/p) setEvents: events]
        ifFalse: [self error: 'the number of events must be greater than 0']! !

!Gamma class methodsFor: 'facts representation' stamp: 'BG 4/9/2001 10:06'!
nameOfDistribution

   ^'Gamma-Distribution'! !


!Geometric class methodsFor: 'instance creation'!
mean: m

    ^self parameter: m! !

!Geometric class methodsFor: 'Examples'!
CarsArriving

    | sample |
    
    "two cars arrive every minute"
    sample := Geometric mean: 60/2.

    "what is the probability that it will take 30 sec before the next car arrives?"
    sample density: 30.

    "Did the next car arrive in 30 to 40 seconds?"
    sample distribution: (30 to: 40)! !


!Maxwell class methodsFor: 'facts representation' stamp: 'BG 4/9/2001 10:04'!
nameOfDistribution

   ^'Maxwell-Distribution'! !


!Normal class methodsFor: 'instance creation'!
mean: a deviation: b
    b > 0.0
    ifTrue: [^self new setMean: a standardDeviation: b]
    ifFalse: [self error: 'standard deviation must be greater than 0.0']! !

!Normal class methodsFor: 'facts representation' stamp: 'BG 4/5/2001 20:25'!
canHaveTwoTails

   ^true! !

!Normal class methodsFor: 'facts representation' stamp: 'BG 4/8/2001 18:11'!
instanceCreationMethod

   ^#mean:deviation:! !

!Normal class methodsFor: 'facts representation' stamp: 'BG 4/5/2001 20:25'!
isSymmetric

   ^true! !

!Normal class methodsFor: 'facts representation' stamp: 'BG 4/5/2001 20:25'!
nameOfDistribution

   ^'Normal Distribution'! !


!Poisson class methodsFor: 'instance creation'!
mean: p

    p > 0.0
        ifTrue: [^self new setMean: p]
        ifFalse: [self error: 'mean must be greater than 0.0']! !


!Resource methodsFor: 'accessing'!
acquire
    ^self! !

!Resource methodsFor: 'accessing'!
addRequest: aDelayedEvent
    pending add: aDelayedEvent.
    self provideResources.
    aDelayedEvent pause.! !

!Resource methodsFor: 'accessing'!
name
    ^resourceName! !

!Resource methodsFor: 'private'!
provideResources
    ^self! !

!Resource methodsFor: 'private'!
setName: aString
    resourceName := aString.
    pending := SortedCollection new! !


!Resource class methodsFor: 'instance creation'!
named: resourceName
    ^self new setName: resourceName! !


!ResourceCoordinator methodsFor: 'accessing'!
customersWaiting
    ^whoIsWaiting == #customer! !

!ResourceCoordinator methodsFor: 'accessing'!
queueLength
    ^pending size! !

!ResourceCoordinator methodsFor: 'accessing'!
serversWaiting
    ^whoIsWaiting == #server! !

!ResourceCoordinator methodsFor: 'task language'!
acquire
    |waiting|
    self customersWaiting ifTrue: [^self giveService].
    "get here if there is no customer waiting for the server."
    waiting := WaitingSimulationObject for: 1 withPriority: 0.
    whoIsWaiting := #server.
    self addRequest: waiting.
    ^waiting resource! !

!ResourceCoordinator methodsFor: 'task language'!
producedBy: aCustomer
    |waiting|
    waiting := WaitingSimulationObject for: 1
                    of: aCustomer
                    withPriority: 0.
    self serversWaiting ifTrue: [^self getServiceFor: waiting].
    whoIsWaiting := #customer.
    self addRequest: waiting! !

!ResourceCoordinator methodsFor: 'private'!
getServiceFor: aCustomerRequest

    | aServerRequest |
    aServerRequest := pending removeFirst.
    pending isEmpty ifTrue: [whoIsWaiting := #none].
    aServerRequest resource: aCustomerRequest.
    aServerRequest resume.
    aCustomerRequest pause! !

!ResourceCoordinator methodsFor: 'private'!
giveService
    |aCustomerRequest|
    aCustomerRequest:= pending removeFirst.
    pending isEmpty ifTrue: [whoIsWaiting := #none].
    ^aCustomerRequest! !

!ResourceCoordinator methodsFor: 'private'!
setName: aString
    super setName: aString.
    whoIsWaiting := #none! !


!ResourceProvider methodsFor: 'accessing'!
amountAvailable
    ^amountAvailable! !

!ResourceProvider methodsFor: 'task language'!
acquire: amountNeeded withPriority: priorityNumber 
    | waiting |
    waiting := WaitingSimulationObject
                    for: amountNeeded 
                    of: self
                    withPriority: priorityNumber.
    self addRequest: waiting.
    ^waiting! !

!ResourceProvider methodsFor: 'task language'!
produce: amount
    amountAvailable := amountAvailable + amount.
    self provideResources! !

!ResourceProvider methodsFor: 'private'!
provideResources
    | waiting |
    [pending isEmpty not and: [pending first amount <= amountAvailable]]
        whileTrue: 
            [waiting := pending removeFirst.
            amountAvailable := amountAvailable - waiting amount.
            waiting resume]! !

!ResourceProvider methodsFor: 'private'!
setName: aResourceName with: amount
    super setName: aResourceName.
    amountAvailable := amount! !


!ResourceProvider class methodsFor: 'instance creation'!
named: aResourceName
    ^self new setName: aResourceName with: 0! !

!ResourceProvider class methodsFor: 'instance creation'!
named: aResourceName with: amount
    ^self new setName: aResourceName with: amount! !


!SampleSpace methodsFor: 'probability functions'!
density: x
    "x must be in the sample space;  the probability must sum over all occurrences of x in the sample space."

    (data includes: x)
        ifTrue: [^(data occurrencesOf: x) / data size]
        ifFalse: [^0]! !

!SampleSpace methodsFor: 'private'!
inverseDistribution: x
    
    ^data at: (x*data size) truncated + 1! !

!SampleSpace methodsFor: 'private'!
setData: aCollection
    
    data := aCollection! !


!SampleSpace class methodsFor: 'instance creation'!
data: aCollection
    
    ^self new setData: aCollection! !

!SampleSpace class methodsFor: 'Examples'!
heights

    | heights |
    heights := SampleSpace data: #(60 60 60 62 62 64 64 64 64 66 66 66 68 68 68 68 68 70 70 70).
    
    "what is the probability of randomly selecting a student with height 64?"
    heights density: 64.

    "what is the probability of randomly selecting a student whose height is between 60 and 64?"
    heights distribution: (60 to: 64 by: 2)! !


!SampleSpaceWithReplacement methodsFor: 'as yet unclassified' stamp: 'BG 1/23/2002 07:28'!
atEnd

  ^ false! !

!SampleSpaceWithReplacement methodsFor: 'as yet unclassified' stamp: 'BG 1/23/2002 07:28'!
do: aBlock
        "Evaluate aBlock once for each element in the
         receiver, from the current position to the end."
    [self atEnd]
        whileFalse: [aBlock value: self next]! !

!SampleSpaceWithReplacement methodsFor: 'as yet unclassified' stamp: 'BG 1/23/2002 07:28'!
isEmpty

   ^ self size = 0! !

!SampleSpaceWithReplacement methodsFor: 'as yet unclassified' stamp: 'BG 1/23/2002 07:28'!
next

  self isEmpty
    ifTrue:  [self error: 'no value exist in the sample space'].
  ^ data at: (rand next * data size) truncated + 1! !

!SampleSpaceWithReplacement methodsFor: 'as yet unclassified' stamp: 'BG 1/23/2002 07:28'!
next: anInteger

    | aCollection |

  aCollection := OrderedCollection new: anInteger.
  anInteger timesRepeat: [aCollection addLast: self next].
  ^ aCollection! !

!SampleSpaceWithReplacement methodsFor: 'as yet unclassified' stamp: 'BG 1/23/2002 07:29'!
setData: aSequenceableCollection

  data := aSequenceableCollection.
  rand := Random new.! !

!SampleSpaceWithReplacement methodsFor: 'as yet unclassified' stamp: 'BG 1/23/2002 07:29'!
size

^ data size! !


!SampleSpaceWithReplacement class methodsFor: 'instance creation' stamp: 'BG 1/23/2002 07:27'!
data: aSequenceableCollection

  ^ self new setData: aSequenceableCollection! !


!SampleSpaceWithoutReplacement methodsFor: 'as yet unclassified' stamp: 'BG 1/23/2002 07:32'!
atEnd

  ^self size = 0! !

!SampleSpaceWithoutReplacement methodsFor: 'as yet unclassified' stamp: 'BG 1/23/2002 07:33'!
next

  ^ data remove: super next! !

!SampleSpaceWithoutReplacement methodsFor: 'as yet unclassified' stamp: 'BG 1/23/2002 07:33'!
setData: aCollection

  data := aCollection asOrderedCollection.
  rand := Random new.! !


!SimpsonRule methodsFor: 'integration' stamp: 'BG 4/15/2001 16:23'!
value

  | interval n area xi factors |

     " compute an initial approximation "
   n := 1. " number of intervals "
   interval := xHigh - xLow / 2.0.
   xi := xLow + interval.
   area := ((function value: xi) * 4
              + (function value: xLow) + (function value: xHigh)
           ) * (xHigh - xLow / 6.0).

   "  begin the repeated division of the integration intervals. "

    factors := #(4.0 2.0 2.0 4.0).

   [ | oldArea sum xPoints delta |
    oldArea := area.
    sum := 0.0.
    delta:= interval / 3.0.
    xPoints := Array new: 4.
    xPoints at: 1 put: delta.
    xPoints at: 2 put: delta * 2.0.
    xPoints at: 3 put: delta * 4.0.
    xPoints at: 4 put: delta * 5.0.

    0 to: n - 1 do:
    [ :i |    | localStart s |
      " compute the function values at the new supporting points.
        Eight new points are needed for evere interval."
       localStart := i*interval * 2 + xLow.
       s := 0.0.
       1 to: xPoints size do:
         [ :j | s := (function value: (xPoints at: j) + localStart) * (factors at: j) + s].
       sum := s + sum.
    ].

    n := n + n + n.
    area := area / 3.0 + (sum * (xHigh - xLow/n / 6.0)).
    interval := interval / 3.0.
    n > nMax or:
      [(area - oldArea) abs <=  (area abs * eps)]
   ]
     whileFalse: [].

  ^area! !


!Simulation methodsFor: 'as yet unclassified' stamp: 'BG 1/22/2002 23:57'!
printStatisticsOn: aStream! !

!Simulation methodsFor: 'as yet unclassified' stamp: 'BG 1/22/2002 23:59'!
resources
        "Answer the value of resources."
    ^resources! !

!Simulation methodsFor: 'task language'!
coordinate: resourceName
    (self includesResourceFor: resourceName)
        ifFalse: [resources add: ( ResourceCoordinator named: resourceName)]! !

!Simulation methodsFor: 'task language'!
produce: amount of: resourceName 
    (self includesResourceFor: resourceName)
        ifTrue: [(self provideResourceFor: resourceName)
                produce: amount
            "sends produce: to a ResourceProvider"]
        ifFalse: [resources add: (ResourceProvider named: resourceName with: amount)]! !

!Simulation methodsFor: 'task language' stamp: 'BG 3/11/2006 11:51'!
produce: amount ofResource: resourceName 
  RunningSimulation produce: amount of:  resourceName.! !

!Simulation methodsFor: 'task language'!
schedule: actionBlock after: timeDelay
    self schedule: actionBlock at: currentTime + timeDelay! !

!Simulation methodsFor: 'task language'!
schedule: aBlock at: timeInteger
    "This is the mechanism for scheduling a single action."
    self newProcessFor: [self delayUntil: timeInteger.  aBlock value]! !

!Simulation methodsFor: 'task language'!
scheduleArrivalOf: aSimulationObjectClass accordingTo: aProbabilityDistribution 
    "This means start now"

    self
        scheduleArrivalOf: aSimulationObjectClass
        accordingTo: aProbabilityDistribution
        startingAt: currentTime! !

!Simulation methodsFor: 'task language'!
scheduleArrivalOf: aSimulationObjectClass accordingTo: aProbabilityDistribution startingAt: timeInteger 
    "Note that aSimulationObjectClass is the class Simulation or one of 
    its subclasses.  The real work is done in the private message 
    schedule:startingAt:andThenEvery:. "

    self
        schedule: [aSimulationObjectClass new startUp]
        startingAt: timeInteger
        andThenEvery: aProbabilityDistribution! !

!Simulation methodsFor: 'task language'!
scheduleArrivalOf: aSimulationObject at: timeInteger 
    self schedule: [aSimulationObject startUp]
        at: timeInteger! !

!Simulation methodsFor: 'initialization'!
activate
    "This instance is now the active simulation"    
    RunningSimulation := self! !

!Simulation methodsFor: 'initialization'!
defineArrivalSchedule
    "A subclass specifies the schedule by which simulation objects dynamically enter into the simulation."
    ^self! !

!Simulation methodsFor: 'initialization'!
defineResources
    "A subclass specifies the schedule by which simulation objects that are initially entered into the simulation."
    ^self! !

!Simulation methodsFor: 'initialization' stamp: 'BG 3/9/2006 21:52'!
initialize
    resources := Set new.
    currentTime := 0.0.
    processCount := 0.
    terminated := false.
    eventQueue := SortedCollection new! !

!Simulation methodsFor: 'scheduling'!
delayFor: timeDelay
    self delayUntil: currentTime+timeDelay! !

!Simulation methodsFor: 'scheduling'!
delayUntil: aTime
    | delayEvent |
    delayEvent := DelayedEvent onCondition: aTime.
    eventQueue add: delayEvent.
    "self stopProcess."
    delayEvent pause.
    "self startProcess"! !

!Simulation methodsFor: 'scheduling'!
newProcessFor: aBlock
    self startProcess.
    [aBlock value. self stopProcess] fork! !

!Simulation methodsFor: 'scheduling'!
startProcess
    processCount := processCount +1! !

!Simulation methodsFor: 'scheduling'!
stopProcess
    processCount := processCount - 1! !

!Simulation methodsFor: 'simulation control'!
enter: anObject
    ^self! !

!Simulation methodsFor: 'simulation control'!
exit: anObject
    ^self! !

!Simulation methodsFor: 'simulation control' stamp: 'BG 3/7/2006 21:55'!
finishUp
    "We need to empty out the event queue."
    eventQueue := SortedCollection new.
    ^false! !

!Simulation methodsFor: 'simulation control' stamp: 'BG 3/11/2006 19:50'!
proceed
    | eventProcess |
    [self readyToContinue]
        whileFalse: [Processor yield].
    eventQueue isEmpty
        ifTrue: [^self finishUp]
        ifFalse: 
            [eventProcess := eventQueue removeFirst.
            currentTime := eventProcess condition.
            eventProcess resume].
    ^true.! !

!Simulation methodsFor: 'simulation control'!
startUp
    self activate.
    self defineResources.
    self defineArrivalSchedule! !

!Simulation methodsFor: 'accessing'!
includesResourceFor: resourceName 
    | test |
    test := resources 
                detect: [:each | each name = resourceName]
                ifNone: [nil].
    ^test notNil! !

!Simulation methodsFor: 'accessing' stamp: 'BG 3/9/2006 21:52'!
isTerminated
   ^terminated! !

!Simulation methodsFor: 'accessing'!
provideResourceFor: resourceName
    ^resources detect: [ :each | each name = resourceName]! !

!Simulation methodsFor: 'accessing' stamp: 'BG 3/9/2006 22:50'!
terminate 
  | queue |
   terminated := true.
   queue := eventQueue.
   eventQueue := SortedCollection new.

   queue do: [:delayedEvent | 
	delayedEvent terminateWaitingProcess].
    [self readyToContinue]
        whileFalse: [Processor yield].! !

!Simulation methodsFor: 'accessing' stamp: 'BG 3/11/2006 22:04'!
terminate: aStream 
  | queue |
   terminated := true.
   queue := eventQueue.
   eventQueue := SortedCollection new.

   queue do: [:delayedEvent | 
	delayedEvent terminateWaitingProcess].
    [self readyToContinue]
        whileFalse: [Processor yield].! !

!Simulation methodsFor: 'accessing'!
time
    ^currentTime! !

!Simulation methodsFor: 'private'!
readyToContinue
    ^processCount = 0! !

!Simulation methodsFor: 'private' stamp: 'BG 3/10/2006 22:15'!
schedule: aBlock startingAt: timeInteger andThenEvery: aProbabilityDistribution 
    self newProcessFor: 
        [self delayUntil: timeInteger.
          self isTerminated
	       ifFalse:
	           [self newProcessFor: aBlock copy.
                    aProbabilityDistribution do: 
                         [:nextTimeDelay | 
                             self delayFor: nextTimeDelay.
                             self isTerminated
	                        ifFalse: [ self newProcessFor: aBlock copy]
	]]].

" This is the important piece of code. "! !

!Simulation methodsFor: 'reporting'!
report: label
    Transcript show: label.
    Transcript tab.
    Transcript show: 'pc: ', processCount printString.
    Transcript space.
    Transcript show: 'procs: ', (Processor processesAt: Processor userSchedulingPriority) printString.
    Transcript space.
    Transcript show: 'events: ', eventQueue size printString.
    Transcript cr! !

!Simulation methodsFor: 'reporting' stamp: 'BG 3/9/2006 21:23'!
report: label into: aStream
    aStream nextPutAll: label.
    aStream tab.
    aStream nextPutAll: 'pc: ', processCount printString.
    aStream space.
    aStream nextPutAll: 'procs: ', (Processor processesAt: Processor userSchedulingPriority) printString.
    aStream space.
    aStream nextPutAll: 'events: ', eventQueue size printString.
    aStream cr! !


!Simulation class methodsFor: 'class initialization' stamp: 'BG 1/22/2002 22:56'!
initialize

     " Simulation initialize "

  RunningSimulation := nil.! !

!Simulation class methodsFor: 'accessing'!
active
    ^RunningSimulation! !


!SimulationObject methodsFor: 'as yet unclassified' stamp: 'BG 1/22/2002 23:21'!
printStatisticsOn: aStream! !

!SimulationObject methodsFor: 'task language'!
acquire: amount ofResource: resourceName 
    "Get the resource and then tell it to acquire amount of it.  Answers 
    an instance of StaticResource."

    ^(Simulation active provideResourceFor: resourceName)
        acquire: amount withPriority: 0! !

!SimulationObject methodsFor: 'task language'!
acquire: amount ofResource: resourceName withPriority: priority 
    "Returns a StaticResource"
    ^(Simulation active provideResourceFor: resourceName)
        acquire: amount withPriority: priority! !

!SimulationObject methodsFor: 'task language'!
acquireResource: resourceName
    "Returns a StaticResource"
    ^(Simulation active provideResourceFor: resourceName) acquire! !

!SimulationObject methodsFor: 'task language'!
holdFor: aTimeDelay
    Simulation active delayFor: aTimeDelay! !

!SimulationObject methodsFor: 'task language'!
inquireFor: amount ofResource: resourceName
    ^(Simulation active provideResourceFor: resourceName) amountAvailable >= amount! !

!SimulationObject methodsFor: 'task language'!
numberOfProvidersOfResource: resourceName
    | resource |
    resource := Simulation active provideResourceFor: resourceName.
    resource serversWaiting
        ifTrue: [^resource queueLength]
        ifFalse: [^0]! !

!SimulationObject methodsFor: 'task language'!
numberOfRequestersOfResource: resourceName
    | resource |
    resource := Simulation active provideResourceFor: resourceName.
    resource customersWaiting
        ifTrue: [^resource queueLength]
        ifFalse: [^0]! !

!SimulationObject methodsFor: 'task language'!
produce: amount ofResource: resourceName
    Simulation active produce: amount of: resourceName! !

!SimulationObject methodsFor: 'task language'!
produceResource: resourceName
    ^(Simulation active provideResourceFor: resourceName) producedBy: self! !

!SimulationObject methodsFor: 'task language'!
release: aStaticResource
    ^aStaticResource release! !

!SimulationObject methodsFor: 'task language'!
resourceAvailable: resourceName
    "Does the active simulaton have a resource with this attribute available?"
    ^Simulation active includesResourceFor: resourceName! !

!SimulationObject methodsFor: 'task language'!
resume: anEvent
    ^anEvent resume! !

!SimulationObject methodsFor: 'task language'!
stopSimulation
    Simulation active finishUp! !

!SimulationObject methodsFor: 'initialization'!
initialize
    "Do nothing.  Subclasses will initialize instance variables."

    ^self! !

!SimulationObject methodsFor: 'simulation control'!
finishUp
    "Tell the simulation that the receiver is done with its tasks."
    Simulation active exit: self! !

!SimulationObject methodsFor: 'simulation control'!
startUp
    Simulation active enter: self.
    "First tell the simulation that the receiver is beginning to do my tasks."
    self tasks.
    self finishUp! !

!SimulationObject methodsFor: 'simulation control'!
tasks
    "Do nothing.  Subclasses will schedule activities."
    ^self! !


!EventMonitor methodsFor: 'scheduling'!
finishUp
    super finishUp.
    self timeStamp.
    DataFile nextPutAll: ' exits '.! !

!EventMonitor methodsFor: 'scheduling'!
startUp
    self timeStamp.
    DataFile nextPutAll: ' enters '.
    super startUp! !

!EventMonitor methodsFor: 'task language'!
acquire: amount ofResource: resourceName
    | aStaticResource |
    self timeStamp.
    DataFile nextPutAll: ' requests '.
    amount printOn: DataFile.
    DataFile nextPutAll: ' of ', resourceName.
    aStaticResource := super acquire: amount ofResource: resourceName.
    self timeStamp.
    DataFile nextPutAll: ' obtained '.
    amount printOn: DataFile.
    DataFile nextPutAll: ' of ', resourceName.
    ^aStaticResource! !

!EventMonitor methodsFor: 'task language'!
acquire: amount ofResource: resourceName withPriority: priorityNumber
    | aStaticResource |
    self timeStamp.
    DataFile nextPutAll: ' requests '.
    amount printOn: DataFile.
    DataFile nextPutAll: ' at priority '.
    priorityNumber printOn: DataFile.
    DataFile nextPutAll: ' of ', resourceName.
    aStaticResource := super acquire: amount ofResource: resourceName withPriority: priorityNumber.
    self timeStamp.
    DataFile nextPutAll: ' obtained '.
    amount printOn: DataFile.
    DataFile nextPutAll: ' of ', resourceName.
    ^aStaticResource! !

!EventMonitor methodsFor: 'task language'!
acquireResource: resourceName
    | anEvent |
    self timeStamp.
    DataFile nextPutAll: ' wants to serve for '.
    DataFile nextPutAll: resourceName.
    anEvent := super acquireResource: resourceName.
    self timeStamp.
    DataFile nextPutAll: ' can serve '.
    anEvent resource printOn: DataFile.
    ^anEvent! !

!EventMonitor methodsFor: 'task language'!
holdFor: aTimeDelay
    self timeStamp.
    DataFile nextPutAll: ' holds for '.
    aTimeDelay printOn: DataFile.
    super holdFor: aTimeDelay! !

!EventMonitor methodsFor: 'task language' stamp: 'BG 3/9/2006 22:46'!
holdFor: aTimeDelay doing: aString
    self timeStamp.
    DataFile nextPutAll: ' holds for '.
    aTimeDelay printOn: DataFile.
    DataFile nextPut: $ ; nextPutAll: aString.
    super holdFor: aTimeDelay! !

!EventMonitor methodsFor: 'task language'!
produce: amount ofResource: resourceName
    self timeStamp.
    DataFile nextPutAll: ' produces '.
    amount printOn: DataFile.
    DataFile nextPutAll: ' of ', resourceName.
    super produce: amount ofResource: resourceName! !

!EventMonitor methodsFor: 'task language'!
produceResource: resourceName
    self timeStamp.
    DataFile nextPutAll: ' wants to get service as '.
    DataFile nextPutAll: resourceName.
    super produceResource: resourceName! !

!EventMonitor methodsFor: 'task language'!
release: aStaticResource
    self timeStamp.
    DataFile nextPutAll: ' releases '.
    aStaticResource amount printOn: DataFile.
    DataFile nextPutAll: ' of ', aStaticResource name.
    super release: aStaticResource! !

!EventMonitor methodsFor: 'task language'!
resume: anEvent
    self timeStamp.
    DataFile nextPutAll: ' resumes '.
    anEvent resource printOn: DataFile.
    super resume: anEvent! !

!EventMonitor methodsFor: 'private'!
timeStamp
    DataFile cr.
    Simulation active time printOn: DataFile.
    DataFile tab.
    self printOn: DataFile! !

!EventMonitor methodsFor: 'initialization'!
initialize
    super initialize.
    self setLabel! !

!EventMonitor methodsFor: 'accessing'!
label
    ^label! !

!EventMonitor methodsFor: 'accessing'!
setLabel
    Counter := Counter + 1.
    label := Counter printString.! !

!EventMonitor methodsFor: 'printing'!
printOn: aStream
    self class name printOn: aStream.
    aStream space.
    aStream nextPutAll: self label! !


!EventMonitor class methodsFor: 'class initialization'!
file: aFile
    DataFile := aFile.
    Counter := 0! !


!SimulationObjectRecord methodsFor: 'accessing'!
duration
    ^duration! !

!SimulationObjectRecord methodsFor: 'accessing'!
entrance
    ^entranceTime! !

!SimulationObjectRecord methodsFor: 'accessing'!
entrance: currentTime
    entranceTime := currentTime! !

!SimulationObjectRecord methodsFor: 'accessing'!
exit
    ^entranceTime + duration! !

!SimulationObjectRecord methodsFor: 'accessing'!
exit: currentTime
    duration := currentTime - entranceTime! !

!SimulationObjectRecord methodsFor: 'printing'!
printOn: aStream
    entranceTime printOn: aStream.
    aStream tab.
    duration printOn: aStream! !


!StaticResource methodsFor: 'accessing' stamp: 'BG 3/11/2006 10:39'!
amount
    ^amount! !

!StaticResource methodsFor: 'accessing' stamp: 'BG 3/11/2006 10:39'!
name
    ^resource name! !

!StaticResource methodsFor: 'accessing' stamp: 'BG 3/11/2006 10:39'!
priority
    ^priority! !

!StaticResource methodsFor: 'comparing' stamp: 'BG 3/11/2006 10:39'!
<= aStaticResource
   ^priority <= aStaticResource priority! !

!StaticResource methodsFor: 'task language' stamp: 'BG 3/11/2006 10:40'!
consume: aNumber
  amount := (amount - aNumber) max: 0.! !

!StaticResource methodsFor: 'task language' stamp: 'BG 3/11/2006 10:41'!
release
   resource produce: amount.
   amount := 0.! !

!StaticResource methodsFor: 'private' stamp: 'BG 3/11/2006 10:41'!
setAmount: aNumber resource: aResource withPriority: priorityNumber
  amount := aNumber.
  resource := aResource.
  priority := priorityNumber.! !


!StaticResource class methodsFor: 'instance creation' stamp: 'BG 3/11/2006 10:38'!
for: amount of: aResource withPriority: aNumber
   ^self new setAmount: amount resource: aResource withPriority: aNumber! !


!StatisticsWithSimulation methodsFor: 'initialization'!
initialize
    super initialize.
    statistics := Dictionary new.! !

!StatisticsWithSimulation methodsFor: 'simulation scheduling'!
enter: anObject 
    statistics at: anObject put: (SimulationObjectRecord new entrance: currentTime)! !

!StatisticsWithSimulation methodsFor: 'simulation scheduling'!
exit: anObject 
    (statistics at: anObject) exit: currentTime! !

!StatisticsWithSimulation methodsFor: 'statistics'!
printStatisticsOn: aStream 
    | stat |
    aStream cr.
    aStream nextPutAll: ' Object'.
    aStream tab.
    aStream nextPutAll: 'Entrance Time'.
    aStream tab.
    aStream nextPutAll: 'Duration'.
    aStream cr.
    stat := SortedCollection sortBlock: [:i :j | i value entrance <= j value entrance].
    statistics associationsDo: [:each | stat add: each]. 
    stat do: 
        [:anAssociation | 
        aStream cr.
        anAssociation key printOn: aStream.
        aStream tab.
        anAssociation value printOn: aStream]! !


!StudentT methodsFor: 'private' stamp: 'BG 4/1/2001 16:35'!
quotientOfGammas: arg

   "  for integer arg, compute the value of
      Gamma((arg + 1)/2) / Gamma(arg/2).
      It is essential to perform the computation in such a way that all intermediate results have a reasonable size. The use of fractions with large numerators and denominators should be avoided. "

   arg = 1 ifTrue: [^Float pi sqrt reciprocal].
   arg  = 2 ifTrue: [^Float pi sqrt / 2.0].
   ^(arg - 1) asFloat / (arg - 2) asFloat * (self quotientOfGammas: arg - 2)! !

!StudentT methodsFor: 'private' stamp: 'BG 4/1/2001 16:32'!
setDegreeOfFreedom: n

      | root q |
    degreeOfFreedom := n. 
    root := (Float pi * n) sqrt.

    q := self quotientOfGammas: n.
    constFactor := q/root.! !

!StudentT methodsFor: 'probability functions' stamp: 'BG 3/26/2001 10:23'!
density: x

    ^constFactor / ((x * x / degreeOfFreedom + 1) raisedTo: degreeOfFreedom + 1 /2)! !

!StudentT methodsFor: 'probability functions' stamp: 'BG 3/26/2001 11:31'!
distributionAt: x

   "  return the value of the distribution function at  x "

    
     ^(NewtonRule for: [:arg | self density: arg]
                   from: 0
                   to: x)
         nMax: 320000;
         eps: 1.0e-8;
        value! !

!StudentT methodsFor: 'probability functions' stamp: 'BG 4/1/2001 07:12'!
distributionBetween: x and: y

   "  return the value of the distribution function at  x "

    
     ^(NewtonRule for: [:arg | self density: arg]
                   from: x 
                   to: y)
         nMax: 320000;
         eps: 1.0e-8;
        value! !

!StudentT methodsFor: 'probability functions' stamp: 'BG 4/1/2001 16:45'!
valueForErrorProbability: a

    "  here we use the fact that the density function is  symmetric at zero. It is
       therefore possible to use the equality
         2*Integrate(f(x), 0, z) = Integrate(f(x), -z, z)
       We use a bisection algorithm to find the value of z for which the
       integral Integrate(density(x), -z, z) gives the value 1 - a  "

       | startValue f min max mean |

   startValue := 5.0.
   f := self distributionBetween: 0.0 and: startValue.
   f := f + f.
   1 - f > a
     ifTrue:
       [[min := startValue.
         startValue := startValue + startValue.
         f := self distributionBetween: 0.0 and: startValue.
         f := f + f.
         1 - f > a
        ] whileTrue: [].
        max := startValue.
       ]
     ifFalse:
       [[max := startValue.
         startValue := startValue / 2.0.
         f := self distributionBetween: 0.0 and: startValue.
         f := f + f.
         1 - f > a
        ] whileFalse: [].
        min := startValue.
       ].
     [mean := min + max / 2.0.
         f := self distributionBetween: 0.0 and: mean.
         f := f + f.
      (1 - f - a) abs < 1.0e-7
          ifTrue: [^mean]. 
      1 - f > a
         ifTrue: [min := mean]
         ifFalse: [max := mean].
      ] repeat.

   " example: 
       5 degrees of freedom, error probability: 5 percent 
       (StudentT forDegreeOfFreedom: 5)
             valueForErrorProbability: 0.05
          2.570581436157227
   "
     

   ! !

!StudentT methodsFor: 'visualization support' stamp: 'BG 4/8/2001 19:57'!
usefulDisplayRange

    "  return a region that can be used to display the density function.
       This method uses the fact, that for the normal distribution, which
       is similar to the t-distribution, the region from mu -2.5*sigma to
       ms + 2.5*sigma encloses almost 99 percent of the area below the
       bell-shaped function. "

    | maxVal |
   maxVal := self density: 0.0.
   maxVal := (maxVal * 10.0) ceiling / 10.0.
   ^Array with: (Array with: -5.0
                            with: 5.0)
            with: (Array with: 0 
                            with: maxVal)! !


!StudentT class methodsFor: 'instance creation' stamp: 'BG 4/8/2001 20:21'!
forDegreesOfFreedom: n

   ^self new setDegreeOfFreedom: n! !

!StudentT class methodsFor: 'facts representation' stamp: 'BG 4/5/2001 20:23'!
canHaveTwoTails

   ^true! !

!StudentT class methodsFor: 'facts representation' stamp: 'BG 4/8/2001 20:21'!
instanceCreationMethod

   ^#forDegreesOfFreedom:! !

!StudentT class methodsFor: 'facts representation' stamp: 'BG 4/5/2001 20:23'!
isSymmetric

   ^true! !

!StudentT class methodsFor: 'facts representation' stamp: 'BG 4/5/2001 20:23'!
nameOfDistribution

   ^'Students t-Distribution'! !


!TrapezRule methodsFor: 'integration' stamp: 'BG 3/24/2000 13:53'!
value

  | interval n area |

   interval := xHigh - xLow / 2.0.
   n := 2.
   area := (function value: xLow) + (function value: xHigh)
              * interval.

   [ | oldArea sum i |
    oldArea := area.
    sum := 0.0.
    i := 1.
    [  | xi |
     xi := i*interval + xLow.
     sum := (function value: xi) + sum.
     i := i + 2.
     i > (n - 1)]
      whileFalse: [].

    area := area / 2.0 + (sum * interval).
    interval := interval / 2.0.
    n := n + n.
    n > nMax or:
      [(area - oldArea) abs <= (area abs * eps)]
   ]
     whileFalse: [].

  ^area! !


!Uniform methodsFor: 'accessing'!
mean
    ^ (startNumber + stopNumber)/2! !

!Uniform methodsFor: 'accessing'!
variance
    ^ (stopNumber - stopNumber) squared / 12! !

!Uniform methodsFor: 'probability functions'!
density: x 
    (x between: startNumber and: stopNumber)
        ifTrue: [^1.0 / (stopNumber - startNumber)]
        ifFalse: [^0]! !

!Uniform methodsFor: 'private'!
inverseDistribution: x
    "x is a random  number between 0 and 1"
    ^startNumber + (x * (stopNumber - startNumber))! !

!Uniform methodsFor: 'private'!
setStart: begin toEnd: end
    startNumber := begin.
    stopNumber := end! !


!Uniform class methodsFor: 'instance creation'!
from: begin to: end 
    begin > end
        ifTrue: [self error: 'illegal interval']
        ifFalse: [^self new setStart: begin toEnd: end]! !


!WaitingSimulationObject methodsFor: 'task language'!
consume: aNumber
    amount := (amount - aNumber) max: 0! !

!WaitingSimulationObject methodsFor: 'task language'!
release
    resource produce: amount.
    amount := 0! !

!WaitingSimulationObject methodsFor: 'task language'!
release: anAmount
    resource produce: anAmount.
    amount := amount - anAmount! !

!WaitingSimulationObject methodsFor: 'accessing'!
amount
    ^amount! !

!WaitingSimulationObject methodsFor: 'accessing'!
name
    ^resource name! !

!WaitingSimulationObject methodsFor: 'accessing'!
resource
    ^resource! !

!WaitingSimulationObject methodsFor: 'accessing'!
resource: aResource
    resource := aResource! !

!WaitingSimulationObject methodsFor: 'private'!
setAmount: aNumber resource: aResource
    amount := aNumber.
    resource := aResource! !


!WaitingSimulationObject class methodsFor: 'instance creation'!
for: amount of: aResource withPriority: aNumber
    ^(self onCondition: aNumber) setAmount: amount resource: aResource! !

!WaitingSimulationObject class methodsFor: 'instance creation'!
for: amount withPriority: aNumber
    ^(self onCondition: aNumber) setAmount: amount resource: nil! !


!Weibull methodsFor: 'probability functions' stamp: 'BG 4/9/2001 09:59'!
density: x

  ^ x <= 0
      ifTrue: [0.0]
      ifFalse:
        [(x raisedTo: beta - 1)*alfa*beta*((alfa negated * (x raisedTo: beta)) exp)
        ]! !


!Weibull class methodsFor: 'facts representation' stamp: 'BG 4/9/2001 10:04'!
nameOfDistribution

   ^'Weibull-Distribution'! !

Simulation initialize!
ProbabilityDistribution initialize!

!Binomial reorganize!
('private')
('probability functions' density:)
('random sampling' next)
('-- all --' events:mean:)
!

